#!/bin/bash
#
# shadowfs is Copyright (C) 2003 - 2004 Clifford Wolf
# shadowfs is Copyright (C) 2003 - 2004 LINBIT Information Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. A copy of the GNU General
# Public License can be found at COPYING.

if [ -z "$COWFS_RO" ]; then
	rm -rf test.ro test.rw
	mkdir test.ro test.rw

	(
		cd test.ro
		mkdir -p dir1/dir{a,b,c}
		for x in dir1/dir{a,b,c}/{x,y,z}; do
			echo $x > $x
		done
		cp -r dir1 dir2
	)

	(
		cd test.rw
		ln -s ../test.ro/* .
	)

	export COWFS_RO="$( pwd -P )/test.ro"
	export COWFS_RW="$( pwd -P )/test.rw"

	export LOGFS_BASEPID="$$"
	export LOGFS_ROLOG="$( pwd -P )/test.rw/rolog.txt"
	export LOGFS_RWLOG="$( pwd -P )/test.rw/rwlog.txt"
	touch $LOGFS_ROLOG $LOGFS_RWLOG

	export LD_PRELOAD="$PWD/libcowfs.so:$PWD/liblogfs.so"

	ulimit -v 10240
	exec bash $0
else
	(
		cd test.rw
		cat dir1/dira/x > /dev/null
		echo "Clifford was here" > dir1/dirb/y
		rm -f dir1/dirc/z
		ln -fs x dir1/dirc/y
		mv dir2/dira/x dir2/dira/y
		ln -f dir2/dira/y dir2/dira/z
	)
fi

