/* shadowfs is Copyright (C) 2003 - 2004 Clifford Wolf
 * shadowfs is Copyright (C) 2003 - 2004 LINBIT Information Technologies
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version. A copy of the GNU General
 * Public License can be found at COPYING.
 */

#ifndef WRAPPER

#define WRAPPER(ret, name, args, xargs, action)		\
extern ret (*orig_ ## name) args;			\
void resolve_ ## name();

#define WRAPPER_OPEN(dummy, name, action)		\
extern int (*orig_ ## name)(const char *p, int f, ...);	\
void resolve_ ## name();

#endif

#ifndef MY_WRONLY

#define MY_WRONLY     01
#define MY_CREAT    0100
#define MY_TRUNC   01000

#endif

WRAPPER(FILE *, fopen, (const char *p, const char *m), (p, m), fopen_wrapper(F, P, &R, &E, p, m))
WRAPPER(FILE *, fopen64, (const char *p, const char *m), (p, m), fopen_wrapper(F, P, &R, &E, p, m))

WRAPPER_OPEN(dummy, open, open_wrapper(F, P, &R, &E, p, f))
WRAPPER_OPEN(dummy, open64, open_wrapper(F, P, &R, &E, p, f))

WRAPPER(int, creat, (const char *p, mode_t m), (p, m), open_wrapper(F, P, &R, &E, p, MY_CREAT|MY_WRONLY|MY_TRUNC))
WRAPPER(int, creat64, (const char *p, mode_t m), (p, m), open_wrapper(F, P, &R, &E, p, MY_CREAT|MY_WRONLY|MY_TRUNC))

WRAPPER(int, unlink, (const char *p), (p), generic_wrapper(F, P, &R, &E, p))
WRAPPER(int, mkdir, (const char *p, mode_t m), (p, m), generic_wrapper(F, P, &R, &E, p))
WRAPPER(int, chmod, (const char *p, mode_t m), (p, m), generic_wrapper(F, P, &R, &E, p))

#if GLIBC_IS_UGLY == 1
WRAPPER(int, __xmknod, (int v, const char *p, mode_t m, dev_t *d), (v, p, m, d), generic_wrapper(F, P, &R, &E, p))
#else
WRAPPER(int, mknod, (const char *p, mode_t m, dev_t d), (p, m, d), generic_wrapper(F, P, &R, &E, p))
#endif

WRAPPER(int, symlink, (const char *o, const char *n), (o, n), generic2_wrapper(F, P, &R, &E, o, n))
WRAPPER(int, link, (const char *o, const char *n), (o, n), generic2_wrapper(F, P, &R, &E, o, n))
WRAPPER(int, rename, (const char *o, const char *n), (o, n), generic2_wrapper(F, P, &R, &E, o, n))

WRAPPER(int, utime, (const char *f, const struct utimbuf *b), (f, b), generic_wrapper(F, P, &R, &E, f))
WRAPPER(int, utimes, (const char *f, const struct timeval *t), (f, t), generic_wrapper(F, P, &R, &E, f))

#ifndef WRAP_WRITE_ONLY

WRAPPER(int, stat, (const char *f, struct stat *b), (f, b), readonly_wrapper(F, P, &R, &E, f))
WRAPPER(int, lstat, (const char *f, struct stat *b), (f, b), readonly_wrapper(F, P, &R, &E, f))
WRAPPER(int, access, (const char *p, int m), (p, m), readonly_wrapper(F, P, &R, &E, p))
WRAPPER(int, readlink, (const char *p, char *b, size_t s), (p, b, s), readonly_wrapper(F, P, &R, &E, p))

#endif

#ifdef WRAP_WAIT

WRAPPER(pid_t, wait, (int *s), (s), wait_wrapper(F, P, &R, &E, 0, s, 0))
WRAPPER(pid_t, waitpid, (pid_t p, int *s, int o), (p, s, o), wait_wrapper(F, P, &R, &E, p, s, o))

#endif

